"use strict";

exports.__esModule = true;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createMapPropertyType;

var _MapProperty2 = require("./MapProperty");

var _MapProperty3 = _interopRequireDefault(_MapProperty2);

var _MapShadow2 = require("./MapShadow");

var _MapShadow3 = _interopRequireDefault(_MapShadow2);

var _StateTypes = require("./StateTypes");

var _StateTypes2 = _interopRequireDefault(_StateTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
	Creates an ArrayProperty subclass based on a custom Shadow type.
*/
function createMapPropertyType() {
	var shadowType = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
	var stateSpec = arguments[1];
	var specCallback = arguments[2];

	var ShadowClass;

	// get the shadow class
	if (shadowType instanceof _MapShadow3.default) {
		// shadow class passed into method
		ShadowClass = shadowType;
	} else {
		var CustomMapShadow = function (_MapShadow) {
			_inherits(CustomMapShadow, _MapShadow);

			function CustomMapShadow() {
				_classCallCheck(this, CustomMapShadow);

				return _possibleConstructorReturn(this, Object.getPrototypeOf(CustomMapShadow).apply(this, arguments));
			}

			return CustomMapShadow;
		}(_MapShadow3.default);

		var proto = CustomMapShadow.prototype;
		var names = Object.getOwnPropertyNames(shadowType);
		var name, desc;

		for (var i = 0, len = names.length; i < len; i++) {
			name = names[i];
			desc = Object.getOwnPropertyDescriptor(shadowType, name);

			Object.defineProperty(proto, name, desc);
		}

		ShadowClass = CustomMapShadow;
	}

	// create the property subclass

	var CustomMapProperty = function (_MapProperty) {
		_inherits(CustomMapProperty, _MapProperty);

		function CustomMapProperty() {
			_classCallCheck(this, CustomMapProperty);

			return _possibleConstructorReturn(this, Object.getPrototypeOf(CustomMapProperty).apply(this, arguments));
		}

		_createClass(CustomMapProperty, [{
			key: "shadowClass",
			value: function shadowClass() {
				return ShadowClass;
			}
		}]);

		return CustomMapProperty;
	}(_MapProperty3.default);

	// assign state spec if present to new Property subclass


	CustomMapProperty.stateSpec = stateSpec || _StateTypes2.default.property(CustomMapProperty);

	if (specCallback) {
		specCallback(CustomMapProperty.stateSpec);
	}

	return CustomMapProperty;
}